package com.example.test;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.NameValuePair;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import com.example.httptest.R;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class HttptestActivity extends Activity implements OnClickListener {

  private Button btn = null;
  private TextView tv = null;


  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main);

    btn = (Button)findViewById(R.id.btn1);
    tv = (TextView)findViewById(R.id.tv1);

    btn.setOnClickListener(this);
  }


  @Override
  public void onClick(View v) {
    // {^
    if( v == btn )
    {
      exec_post();

    }
  }


  // POSTʐMsiAsyncTaskɂ񓯊gȂo[Wj
  private void exec_post() {

    Log.d("posttest", "post܂");
    String ret = "";

    // URL
    URI url = null;
    try {
      //url = new URI( "http://10.0.2.2/android_post_test.php" );
      url = new URI( "http://192.168.1.5/android_post_test.php" );
      Log.d("posttest", "URLOK");
    } catch (URISyntaxException e) {
      e.printStackTrace();
      ret = e.toString();
    }

    // POSTp[^tPOSTNGXg\z
    HttpPost request = new HttpPost( url );
    List<NameValuePair> post_params = new ArrayList<NameValuePair>();
    post_params.add(new BasicNameValuePair("post_1", "[UID"));
    post_params.add(new BasicNameValuePair("post_2", "pX[h"));
    try {
      // Mp[^̃GR[hw
      request.setEntity(new UrlEncodedFormEntity(post_params, "UTF-8"));
    } catch (UnsupportedEncodingException e1) {
      e1.printStackTrace();
    }

    // POSTNGXgs
    DefaultHttpClient httpClient = new DefaultHttpClient();
    try {
      Log.d("posttest", "POSTJn");
      ret = httpClient.execute(request, new ResponseHandler<String>() {

        @Override
        public String handleResponse(HttpResponse response) throws IOException
        {
          Log.d(
            "posttest", 
            "X|XR[hF" + response.getStatusLine().getStatusCode()
          );

          // ɎMłꍇ200
          switch (response.getStatusLine().getStatusCode()) {
          case HttpStatus.SC_OK:
            Log.d("posttest", "X|X擾ɐ");

            // X|Xf[^GR[hς݂̕ƂĎ擾
            return EntityUtils.toString(response.getEntity(), "UTF-8");

          case HttpStatus.SC_NOT_FOUND:
            Log.d("posttest", "f[^݂Ȃ");
            return null;

          default:
            Log.d("posttest", "ʐMG[");
            return null;
          }

        }
        
      });

    } catch (IOException e) {
      Log.d("posttest", "ʐMɎsF" + e.toString());
    } finally {
      // shutdownƒʐMłȂ
      httpClient.getConnectionManager().shutdown();
    }

    // MʂUIɕ\
    tv.setText( ret );

  }
}
